#!/bin/bash
########################################################################
# yapkd.sh - Yet Another Port Knocking  Daemon		               #
#								       #
#   Copyright (C) 2007-2008  Anathema`				       #
#								       #
#   This program is free software: you can redistribute it and/or      #
#   modify it under the terms of the GNU General Public License as     #
#   published by the Free Software Foundation, either version 3 of     #
#   the License, or  any later version.				       #
#								       #
#   This program is distributed in the hope that it will be useful,    #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of     #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      #
#   GNU General Public License for more details.		       #
#								       #
#   You should have received a copy of the GNU General Public License  #
#   along with this program.  If not, see			       #
#   <http://www.gnu.org/licenses/>.				       #
#								       #
#								       #
#  Cheers to all ex-screw and ex-b.r. :)                               #
########################################################################


# The file with the keys in must be in the form:
#
# firstkey
# secondkey
# thirdkey
# and so on...

## KEY FILE:
FILE="passwd"

 if [ ! -s ${FILE} ]; then # check if $FILE exist
    echo "[!] Password file not found."
    exit 1
 fi

RUID=0

if [ "${UID}" != "${RUID}" ]; then
    echo "[!] You must be root."
    exit 1
fi


key="key.md5"


## Port to listen on:
PORT="2007"

## Working dir:
PWD=`pwd`

###########################
#                         #
###### BEGIN OF CODE ######
#                         #
###########################


# Function checking if the login on ssh was successful
function checksshd() {
	ret=$(ps auxw | grep sshd: | grep -v grep >/dev/null; echo $?) # see if someone is logged in
	if [ "${ret}" != "0" ]; then # if not
		echo "[!] Noone logged in! shutting down sshd..." # kill sshd
		killall -9 sshd
                break
	fi
	sleep 2
}

# Main port knocking loop
function mainloop() {
	echo "[+] Waiting for auth on port ${PORT}."
	nc -l -p ${PORT} > ${key} # run the listening netcat and wait for a key

        echo "[*] Got file - file is ${key} - checking..."

	rkey=$(md5sum -c /${PWD}/${key} &>/dev/null; echo $?) # md5 check sum
	if [ ${rkey} != 0 ]; then # if the keys are different
		echo "[!] Wrong key supplied. Going to sleep..."
                rm ${key}
		sleep 15 # go down for 15 seconds
	else # otherwise
		echo "[*] Key is valid - Opening sshd..."
		/usr/sbin/sshd # open sshd
	fi
         rm ${key}

	echo "[+] Waiting for login in 15 seconds..."
	sleep 15 # let the user login in 15 seconds
	echo "[+] Checking for logged in users..."
	while true; do checksshd; done # then launch the checking loop
}

# start the whole thing
while true; do mainloop; done
